Program Basic;
{
Nazev : Interpretr BASIC-u
Verze : 1.0
PGJ   : Pascal, dialekt Turbo Pascal 7.0
Autor : Ladislav Sobr
Datum : 14.12.1998

Program vznikl jako zapoctovy program pro cviceni z programovani
na MFF UK v zimnim semestru.
}

USES Crt;

CONST PPZI = 10; {Pocet platnych znaku identifikatoru}
      MaxPocPromennych = 500;
      MaxPocPoli = 30;
      MaxPocOdkazu = 300;   {GOSUB - RETURN}
      MaxRozmerPole = 10;
      MaxPocRadku = 16000; {ve skutecnosti jeste +1}

      Epsilon = 5.0e-7;{meni se pouze rad!!!!; max -9 ... kvuli MaxLongInt}
      RadZaokrouhleni = Round(1 / Epsilon / 2);
      VypisRZ = 6;     {melo by to byt o "rad" mene nez Epsilon, ale kladne}

      Odsazeni = 10;   {tabelace pri vypisu}
      AlokacniLimit = 65000;  {kolik dovolim poli}


TYPE PromTyp = Real;
     PPromTyp = ^PromTyp;

     RPromenna = record
                   Jmeno     :String[PPZI];
                   Hodnota   :PromTyp;
                 end;
     PPromenna = ^RPromenna;
     RPromenne = array[1..MaxPocPromennych] of RPromenna;

     RPromennaPole = record
                       Jmeno     :String[PPZI];
                       Rozmer    :Integer;
                       SP        :array[1..MaxRozmerPole] of Integer;
                       Data      :Pointer;
                     end;
     RPole = array[1..MaxPocPoli] of RPromennaPole;

     RRadek = record
                Cislo   :Integer;  {cislo radku, na kterem byl prikaz ve zdrojaku}
                                   {je to pouze kvuli vypisu chyb }
                Navesti :Integer;
                Znacka  :Integer;
                Telo    :String;
              end;
     RProg = array[1..MaxPocRadku + 1] of ^RRadek;

CONST PromNula :RPromenna = (Jmeno :'NULA'; Hodnota :0);

VAR Promenne                    :^RPromenne;
    Pole                        :^RPole;
    PocPromennych               :Integer;
    PocPoli                     :Integer;

    GosubOdkazy                 :array[1..MaxPocOdkazu] of Integer;

    PocGosubOdkazu              :Integer;

    Prog                        :^RProg;
    PocRadku                    :Integer;

    ProgRadek                   :Integer;

    OldExitProc                 :Pointer;
{==================================================}

Function VyhodnotCiselnyVyraz(S :String; var Poz :Integer) :PromTyp; forward;
Procedure DisposeProgram; forward;
Procedure Done; forward;

{==================================================}

Procedure OdstranMezery(var S :String);
var i :Integer;
begin
  i:=1;
  While (i <= Length(S)) and (S[i] = ' ') do Inc(i);
  S:=Copy(S, i, Length(S));
  While (Length(S) > 0) and (S[Length(S)] = ' ') do S[0]:=Pred(S[0]);
end;

Procedure PosunPresMezery(const S :String; var P :Integer);
begin
  While (S[P] = ' ') and (P <= Length(S)) do Inc(P);
end;

Function Max(i1, i2 :Integer) :Integer;
begin
  if i1 > i2 then Max:=i1
  else Max:=i2;
end;

Function Zaokrouhli(R :PromTyp) :PromTyp;
begin
  if (R > MaxLongInt) or (R < -MaxLongInt) then Zaokrouhli:=R
  else if R >=0 then Zaokrouhli:=Int(R * RadZaokrouhleni + 0.5) / RadZaokrouhleni
       else Zaokrouhli:=Int(R * RadZaokrouhleni - 0.5) / RadZaokrouhleni;
end;

Function Hex(L :LongInt) :String;
var   S :String[8];
const H :array[0..15] of char = '0123456789ABCDEF';
begin
  S:='';
  Repeat
    S:=H[L mod 16] + S;
    L:=L shr 4;
  until L = 0;
  Hex:=S;
end;


{===== upravy radku zdrojoveho souboru ======}

Procedure SpecUpCase(var S :String);
{zvetsi pismena mimo retezcu v uvozovkach}
var i, j :Integer;
begin
  j:=0;
  For i:=1 to Length(S) do
  if S[i] = '"' then j:=(j + 1) mod 2
  else if (j = 0) and (S[i] in ['a'..'z']) then
         S[i]:=Chr(Ord(S[i]) - Ord('a') + Ord('A'));
end;

Procedure OdstranNadbytecnaPlusAMinus(var S :String);
var Ch :Char;
    i, j  :Integer;
begin
  i:=1;
  Ch:=#0;  {cokoli kromne + -}
  j:=0;
  While i <= Length(S) do
  begin
    case S[i] of
      '+' : if (Ch = '+') or (Ch = '-') then
            begin
              S:=Copy(S, 1, i - 1) + Copy(S, i + 1, Length(S) - i);
              Continue;
            end;
      '-' : if (Ch = '+') or (Ch = '-') then
            begin
              S:=Copy(S, 1, j - 1) + Copy(S, j + 1, Length(S) - j);
              Dec(i);
              if Ch = '-' then S[i]:='+';
            end;
    end;
    if S[i] <> ' ' then
    begin
      j:=i;
      Ch:=S[i];
    end;
    Inc(i);
  end;
end;


{===== Hledani retezcu s urcitymi vlastnostmi =========}

Function NajdiNeuzavorkovanyRetezec(S, S2 :String; Od :Integer) :Integer;
var i, j, Poz, z :Integer;
begin
{?}  if S2 = '' then NajdiNeuzavorkovanyRetezec:=0;
  S:=Copy(S, Od, Length(S));
  i:=Pos(S2, S);
  Poz:=0;
  z:=0;
  While (i <> 0) and (S <> '') do
  begin
    For j:=1 to i - 1 do
      if S[j] = '(' then Inc(z)
      else if S[j] = ')' then Dec(z);
    if z = 0 then
    begin
      NajdiNeuzavorkovanyRetezec:=Poz + i;
      Exit;
    end;
    S:=Copy(S, i + Length(S2), Length(S));
    Poz:=Poz + i + Length(S) - 1;
    i:=Pos(S2, S);
  end;
  NajdiNeuzavorkovanyRetezec:=0;
end;

Function NajdiProgRetezec(S, S2 :String; Od :Integer; KeyWord :Boolean) :Integer;
{najde retezec S2 v S mimo uvozovky, zacina hledat od pozice Od}
{pokud KeyWord = True tak hleda pouze retezce odpovidajici prikazum}
{nenajde-li vrati nulu}
var i, j, Poz, z :Integer;
begin
{?}  if S2 = '' then NajdiProgRetezec:=0;
  S:=Copy(S, Od, Length(S));
  i:=Pos(S2, S);
  Poz:=0;
  z:=0;
  While (i <> 0) and (S <> '') do
  begin
    For j:=1 to i - 1 do
    if S[j] = '"' then z:=(z + 1) mod 2;
    if z = 0 then
    begin
      if not KeyWord or
         (((Poz + i + Od - 1 = 1) or (S[i - 1] = ' ') or (S[i - 1] = ':'))
           and ((Length(S) = Length(S2) + i - 1) or (S[i + Length(S2)] = ' ') or (S[i + Length(S2)] = ' '))) then
      begin
        NajdiProgRetezec:=Poz + i + Od - 1;
        Exit;
      end;
    end;
    S:=Copy(S, i + Length(S2), Length(S));
    Poz:=Poz + i + Length(S) - 1;
    i:=Pos(S2, S);
  end;
  NajdiProgRetezec:=0;
end;


Procedure Chyba(Cislo :Integer);
var S :String;
begin
  S:='';
  case Cislo of
    1 : S:='Chybna syntaxe';
    2 : S:='Chybi (';
    3 : S:='Chybi )';
    4 : S:='Chybi [';
    5 : S:='Chybi ]';
    6 : S:='Chybi =';
    7 : S:='Chybi "';
    8 : S:='Chybi ,';
    9 : S:='Chybi , nebo ;';
    10 : S:='Chybi TO';
    11 : S:='Chybi THEN';
    12 : S:='Chybi ENDIF';
    13 : S:='RETURN bez GOSUB';
    14 : S:='Chybi NEXT';
    15 : S:='NEXT bez FOR';
    16 : S:='Chybi identifikator';
    17 : S:='Identifikator je shodny s vyhrazenym slovem';
    18 : S:='Neplatny identifikator';

    19 : S:='Prilis mnoho promennych';

    20 : S:='Nezname pole';
    21 : S:='Prilis mnoho poli';
    22 : S:='Prilis velke pole';
    23 : S:='Souradnice pole neni cele cislo';
    24 : S:='Neplatna hodnota souradnice pole';
    25 : S:='Souradnice prvku mimo rozsah pole';

    26 : S:='Neplatne navesti';
    27 : S:='Duplicitni navesti';
    28 : S:='Chybi cislo navesti';
    29 : S:='Navesti nenalezeno';

    30 : S:='Ocekavana celociselna hodnota';
    31 : S:='Hodnota mimo rozsah 0 az 15';

    32 : S:='Prilis mnoho vnorenych podprogramu';
    33 : S:='Prilis mnoho prikazu';
    34 : S:='Chybi zdroj nahodnych cisel';
    35 : S:='Soubor nenalezen';
    36 : S:='Chybi zdrojovy soubor';

    37 : S:='Hodnota mimo rozsah 0 az 30000';

    200 : S:='Deleni nulou';
    201 : S:='Chyba rozsahu';
    202 : S:='Preteceni zasobniku';
    203 : S:='Preteceni haldy';
    205 : S:='Preteceni pri ciselne operaci';
    206 : S:='Podteceni pri ciselne operaci';
    207 : S:='Neplatna operace s cisly';
  end;
  if S <> '' then
  begin
    if ProgRadek <= 0 then ProgRadek:=-ProgRadek
    else ProgRadek:=Prog^[ProgRadek]^.Cislo;
    Writeln;
    Writeln('Chyba ', Cislo, ' na radku ', ProgRadek, ' : ', S);
  end
  else
    Writeln('Behova chyba cislo ', Cislo, ' na adrese ', Hex(Seg(ErrorAddr)), ':', Hex(Ofs(ErrorAddr)));
  DisposeProgram;
  Done;
  Halt(Cislo);
end;


{===== Promenne a pole ======================}

Procedure TestIdentifikatoru(S :String);
var i :Integer;
begin
  OdstranMezery(S);
  if (S = 'LET') or (S = 'REM') or (S = 'GOTO') or (S = 'GOSUB')
     or (S = 'RETURN') or (S = 'FOR') or (S = 'TO') or (S = 'STEP')
     or (S = 'IF') or (S = 'THEN') or (S = 'ELSE') or (S = 'ENDIF')
     or (S = 'INPUT') or (S = 'PRINT') or (S = 'NEXT') or (S = 'DIM')
     or (S = 'END') or (S = 'CLS') or (S = 'RANDOMIZE') or (S = 'WRITE')
     or (S = 'INT') or (S = 'ROUND') or (S = 'SIN') or (S = 'COS')
     or (S = 'ARCTAN') or (S = 'RND') or (S = 'PI') or (S = 'SLEEP')
     then Chyba(17);             {identifikator nesmi byt klicove slovo}
  if not (S[1] in ['A'..'Z']) then Chyba(18);     {neplatny identifikator}
  For i:=2 to Length(S) do
  if not (S[i] in ['A'..'Z', '0'..'9', '_']) then Chyba(18); {neplatny identifikator}
end;

Procedure PridejPromennou(S :String; Hodnota :PromTyp);
begin
  if PocPromennych >= MaxPocPromennych then Chyba(19); {moc promennych}
  Inc(PocPromennych);
  Promenne^[PocPromennych].Jmeno:=S;
  Promenne^[PocPromennych].Hodnota:=Hodnota;
end;

Function VratPromennou(var S :String; var Poz :Integer; RO :Boolean) :PPromenna;
{vraci pointer na record RPromenna}
{vstupy : S = retezec se jmennem promenne}
{         Poz = pozice jmena v S}
{         RO = ReadOnly - je-li nastaveno, tak pokud promenna neexistuje,}
{              tak vraci pointer na PromNula a promennou nevytvari }
{vystupy : Poz ukazuje na prvni nezpracovany znak v S}
var i, Pozice :Integer;
    S1 :String;
begin
  PosunPresMezery(S, Poz);
  if Poz > Length(S) then Chyba(16);      {chybi indentifikator}
  if not (S[Poz] in ['A'..'Z']) then Chyba(18); {neplatny identifikator}
  i:=Poz;
  While (Poz <= Length(S)) and (S[Poz] in ['A'..'Z', '0'..'9', '_']) do Inc(Poz);

  S1:=Copy(S, i, Poz - i);
  S1:=Copy(S1, 1, PPZI);
  OdstranMezery(S1);
  TestIdentifikatoru(S1);

  For i:=1 to PocPromennych do
  if Promenne^[i].Jmeno = S1 then
  begin
    VratPromennou:=Addr(Promenne^[i]);
    Exit;
  end;
  if RO then VratPromennou:=Addr(PromNula)
  else
  begin
    PridejPromennou(S1, 0);
    VratPromennou:=Addr(Promenne^[PocPromennych]);
  end;
end;

Procedure IdentifikujPrvekPole(var S :String; var Pol :RPromennaPole; var Poz :Integer);
{vstupy : S = retezec se jmennem a souradnicemi pole (jmeno je na pozici Poz)}
{vystupy : S = jmeno pole}
{          Pol je vyplneno}
{          Poz ukazuje na prvni nezpracovany znak v S}
var i, j :Integer;
    r :PromTyp;
begin
  PosunPresMezery(S, Poz);
  if Poz > Length(S) then Chyba(16);      {chybi indentifikator}
  i:=Poz;
  if not (S[Poz] in ['A'..'Z']) then Chyba(18); {neplatny identifikator}
  While (Poz <= Length(S)) and (S[Poz] in ['A'..'Z', '0'..'9', '_']) do Inc(Poz);
  Pol.Jmeno:=Copy(S, i, Poz - i);
  TestIdentifikatoru(Pol.Jmeno);

  PosunPresMezery(S, Poz);
  if (Poz > Length(S)) or (S[Poz] <> '[') then Chyba(4);      {chybi [ }
  Pol.Rozmer:=0;
  Repeat
    Inc(Poz);
    PosunPresMezery(S, Poz);
    r:=VyhodnotCiselnyVyraz(S, Poz);
    if Abs(r - Round(r)) > Epsilon then Chyba(23);    {souradnice pole musi byt cele cislo}
    if (r < -MaxInt) or (r > MaxInt) then Chyba(24);   {sour. pole max. maxint}
    j:=Round(r);
    if j < 0 then Chyba(24);                {souradnice pole musi byt > 0}
    Inc(Pol.Rozmer);
    Pol.SP[Pol.Rozmer]:=j;
    if (Poz > Length(S)) or ((S[Poz] <> ',') and (S[Poz] <> ']'))
           then Chyba(1);      {syntax error}
  Until S[Poz] = ']';
  Inc(Poz);
end;


Procedure PridejPole(var S :String; var Poz :Integer);
{vstupy : S = retezec se jmennem a souradnicemi pole (jmeno je na pozici Poz)}
{vystupy : Poz ukazuje na prvni nezpracovany znak v S}
var Pol :RPromennaPole;
    i, j :Integer;
    Vel :LongInt;
begin
  IdentifikujPrvekPole(S, Pol, Poz);

  {REDIM}
  j:=PocPoli + 1;
  For i:=1 to PocPoli do
  if Pole^[i].Jmeno = Pol.Jmeno then
  begin
    Vel:=SizeOf(PromTyp);
    For j:=1 to Pole^[i].Rozmer do Vel:=Vel * (Pole^[i].SP[j] + 1);
    FreeMem(Pole^[i].Data, Vel);
    j:=i;
    Break;
  end;
  if j = PocPoli + 1 then Inc(PocPoli);

  {DIM}
  if PocPoli > MaxPocPoli then Chyba(21); {moc poli}
  Vel:=SizeOf(PromTyp);
  For i:=1 to Pol.Rozmer do Vel:=Vel * (Pol.SP[i] + 1);
  if Vel > AlokacniLimit then Chyba(22);        {prilis velke pole}
  GetMem(Pol.Data, Vel);
  FillChar(Pol.Data^, Vel, 0);
  Pole^[j]:=Pol;
end;

Procedure DealokacePoli;
var i :Integer;
    Vel :Word;
begin
  While PocPoli > 0 do
  begin
    With Pole^[PocPoli] do
    begin
      Vel:=SizeOf(PromTyp);
      For i:=1 to Rozmer do Vel:=Vel * (SP[i] + 1);
      FreeMem(Data, Vel);
    end;
    Dec(PocPoli);
  end;
end;

Function VratPrvekPole(var S :String; var Poz :Integer) :PPromTyp;
{vraci primo pointer na "hodnotu" prvku pole}
{vstupy : S = retezec se jmennem a souradnicemi pole (jmeno je na pozici Poz)}
{vystupy : Poz ukazuje na prvni nezpracovany znak v S}
var Pol :RPromennaPole;
    i, j :Integer;
    AktPos, Multi :Word;
begin
  IdentifikujPrvekPole(S, Pol, Poz);

  j:=1;
  For i:=1 to PocPoli do
  if Pole^[i].Jmeno = Pol.Jmeno then
  begin
    j:=0;
    Break;
  end;
  if j = 1 then Chyba(20);                      {neexistujici pole}

  With Pole^[i] do
  begin
    AktPos:=0;
    Multi:=1;
    For i:=2 to Rozmer do Multi:=Multi * (SP[i] + 1);
    For j:=1 to Rozmer do
    begin
      if Pol.SP[j] > SP[j] then Chyba(25);        {neexistujici prvek}
      AktPos:=AktPos + Pol.SP[j] * Multi;
      if j <> Rozmer then Multi:=Multi div (SP[j + 1] + 1);
    end;
    VratPrvekPole:=Ptr(Seg(Data^), Ofs(Data^) + AktPos * SizeOf(PromTyp));
  end;
end;

Function VratPromennouNeboPole(var S :String; var Poz :Integer; RO :Boolean) :PPromTyp;
{vraci primo pointer na "hodnotu" promenne/prvku pole}
{vstupy : S = retezec se jmennem (a u pole s jeho souradnicemi),}
{             jmeno je na pozici Poz}
{vystupy : Poz ukazuje na prvni nezpracovany znak v S}
var i :Integer;
begin
  i:=Poz;
  PosunPresMezery(S, i);
  if i > Length(S) then Chyba(16);      {chybi identifikator}
  if not (S[i] in ['A'..'Z']) then Chyba(18);  {neplatny identifikator}
  Inc(i);
  While (i <= Length(S)) and (S[i] in ['A'..'Z', '0'..'9', '_']) do Inc(i);
  PosunPresMezery(S, i);
  if (i <= Length(S)) and (S[i] = '[') then            {pole}
    VratPromennouNeboPole:=VratPrvekPole(S, Poz)
  else                            {promenna}
    VratPromennouNeboPole:=Addr(VratPromennou(S, Poz, RO)^.Hodnota);
end;



{==== vyhodnocovani vyrazu =================}

Function VyhodnotCiselnyVyraz(S :String; var Poz :Integer) :PromTyp;
{vstupy : S = retezec s vyrazem k vyhodnoceni}
{         Poz = pozice v S od ktere se ma vyraz vyhodnocovat}
{vystupy : Poz = prvni znak, ktery uz do vyrazu nepatri}
  Function VCV1(var S :String; var Poz :Integer) :PromTyp; forward;

  Function VCV3(var S :String; var Poz :Integer) :PromTyp;
  var r, r2 :PromTyp;
      i, j, k :Integer;
      s2 :String[PPZI];
  begin
    PosunPresMezery(S, Poz);
    if Poz > Length(S) then Chyba(1);  {syntax error}
    if S[Poz] = '(' then                {zavorky ?}
    begin
      Poz:=Poz + 1;
      r:=VCV1(S, Poz);
      PosunPresMezery(S, Poz);
      if (Poz > Length(S)) or (S[Poz] <> ')') then Chyba(3);  {chybi ) }
      Poz:=Poz + 1;
    end
    else
    begin
      Val(Copy(S, Poz, Length(S)), r, i);
      if i = 0 then i:=Length(S) + 1;
      Val(Copy(S, Poz, i - 1), r, j);
      if j = 0 then                    {cislo ?}
      begin
        Poz:=Poz + i - 1;
      end
      else
      if Copy(S, Poz, 3) = 'INT' then
      begin
        Poz:=Poz + 3;
        PosunPresMezery(S, Poz);
        if S[Poz] <> '(' then Chyba(2);           {chybi ( }
        Inc(Poz);
        r:=VCV1(S, Poz);
        if S[Poz] = ',' then      {zarovnani desetinnych mist}
        begin
          Inc(Poz);
          r2:=VyhodnotCiselnyVyraz(S, Poz);
          if S[Poz] <> ')' then Chyba(3);           {chybi ) }
          Inc(Poz);
          if (r2 < -MaxInt) or (r2 > MaxInt) then Chyba(31); { 0<=r2<=15 }
          if Abs(r2 - Round(r2)) > Epsilon then Chyba(30); {ocekavana celociselna hodnota}
          i:=Round(r2);
          if (i < 0) or (i > 15) then Chyba(31);            { 0<=r2<=15 }
          For j:=1 to i do r:=r * 10;
          r:=Int(r);
          For j:=1 to i do r:=r / 10;
        end
        else
        begin
          if S[Poz] <> ')' then Chyba(3);           {chybi ) }
          Inc(Poz);
          r:=Int(r);
        end;
      end
      else
      if Copy(S, Poz, 5) = 'ROUND' then
      begin
        Poz:=Poz + 5;
        PosunPresMezery(S, Poz);
        if S[Poz] <> '(' then Chyba(2);           {chybi ( }
        Inc(Poz);
        r:=VCV1(S, Poz);
        if S[Poz] <> ')' then Chyba(3);           {chybi ) }
        Inc(Poz);
        r:=Round(r);
      end
      else
      if Copy(S, Poz, 3) = 'SIN' then
      begin
        Poz:=Poz + 3;
        PosunPresMezery(S, Poz);
        if S[Poz] <> '(' then Chyba(2);           {chybi ( }
        Inc(Poz);
        r:=VCV1(S, Poz);
        if S[Poz] <> ')' then Chyba(3);           {chybi ) }
        Inc(Poz);
        r:=Sin(r);
      end
      else
      if Copy(S, Poz, 3) = 'COS' then
      begin
        Poz:=Poz + 3;
        PosunPresMezery(S, Poz);
        if S[Poz] <> '(' then Chyba(2);           {chybi ( }
        Inc(Poz);
        r:=VCV1(S, Poz);
        if S[Poz] <> ')' then Chyba(3);           {chybi ) }
        Inc(Poz);
        r:=Cos(r);
      end
      else
      if Copy(S, Poz, 6) = 'ARCTAN' then
      begin
        Poz:=Poz + 6;
        PosunPresMezery(S, Poz);
        if S[Poz] <> '(' then Chyba(2);           {chybi ( }
        Inc(Poz);
        r:=VCV1(S, Poz);
        if S[Poz] <> ')' then Chyba(3);           {chybi ) }
        Inc(Poz);
        r:=ArcTan(r);
      end
      else
      if Copy(S, Poz, 3) = 'RND' then
      begin
        Poz:=Poz + 3;
        r:=Random;
      end
      else
      if Copy(S, Poz, 2) = 'PI' then
      begin
        Poz:=Poz + 2;
        r:=PI;
      end
      else r:=VratPromennouNeboPole(S, Poz, True)^; {promenna nebo pole}
    end;
    PosunPresMezery(S, Poz);
    if Poz > Length(S) then VCV3:=r
    else
    begin
      Inc(Poz);
      case S[Poz - 1] of
        '!' : VCV3:=Zaokrouhli(r);
        '%' : if r >= 0 then VCV3:=Int(r + 0.5)
              else VCV3:=Int(r - 0.5);
        else begin
               Dec(Poz);
               VCV3:=r;
             end;
      end;
    end;
  end;

  Function VCV2(var S :String; var Poz :Integer) :PromTyp;
  var r :PromTyp;
  begin
    r:=VCV3(S, Poz);
    PosunPresMezery(S, Poz);
    if Poz <= Length(S) then
    While (S[Poz] = '*') or (S[Poz] = '/') or
          (Copy(S, Poz, 3) = 'DIV') or (Copy(S, Poz, 3) = 'MOD') do
    begin
      if S[Poz] = '*' then
      begin
        Poz:=Poz + 1;
        r:=r * VCV3(S, Poz);
      end
      else
      if S[Poz] = '/' then
      begin
        Poz:=Poz + 1;
        r:=r / VCV3(S, Poz);
      end
      else
      if Copy(S, Poz, 3) = 'DIV' then
      begin
        Poz:=Poz + 3;
        r:=Round(r) div Round(VCV3(S, Poz));
      end
      else
      if Copy(S, Poz, 3) = 'MOD' then
      begin
        Poz:=Poz + 3;
        r:=Round(r) mod Round(VCV3(S, Poz));
      end;
      PosunPresMezery(S, Poz);
      if Poz > Length(S) then Break;
    end;
    VCV2:=r;
  end;

  Function VCV1(var S :String; var Poz :Integer) :PromTyp;
  var r :PromTyp;
  begin
    r:=VCV2(S, Poz);
    PosunPresMezery(S, Poz);
    if Poz <= Length(S) then
    While (S[Poz] = '+') or (S[Poz] = '-') do
    begin
      Poz:=Poz + 1;
      if S[Poz - 1] = '+' then r:=r + VCV2(S, Poz)
      else r:=r - VCV2(S, Poz);
      PosunPresMezery(S, Poz);
      if Poz > Length(S) then Break;
    end;
    VCV1:=r;
  end;

begin
  VyhodnotCiselnyVyraz:=VCV1(S, Poz);
end;


Function VyhodnotLogickyVyraz(S :String) :Boolean;
{na vstupu ma pouze logicky vyraz, nic jineho}
{napr. ne "a=5 then let a=2", pouze "a=5"}
{mezery kolem nevadi}
var i, j :Integer;
    B :Boolean;
    c1, c2 :PromTyp;
begin
  OdstranMezery(S);
  if Length(S) = 0 then Chyba(1);     {syntax error}

  i:=NajdiNeuzavorkovanyRetezec(S, 'OR ', 1);
  if i <> 0 then
  begin
    Repeat
      B:=VyhodnotLogickyVyraz(Copy(S, 1, i - 1));
      S:=Copy(S, i + 2, Length(S));
      i:=NajdiNeuzavorkovanyRetezec(S, 'OR ', 1);
    Until (i = 0) or B;
    if not B then VyhodnotLogickyVyraz:=VyhodnotLogickyVyraz(S)
    else VyhodnotLogickyVyraz:=True;
    Exit;
  end;

  i:=NajdiNeuzavorkovanyRetezec(S, 'AND', 1);
  if i <> 0 then
  begin
    Repeat
      B:=VyhodnotLogickyVyraz(Copy(S, 1, i - 1));
      S:=Copy(S, i + 3, Length(S));
      i:=NajdiNeuzavorkovanyRetezec(S, 'AND', 1);
    Until (i = 0) or not B;
    if B then VyhodnotLogickyVyraz:=VyhodnotLogickyVyraz(S)
    else VyhodnotLogickyVyraz:=False;
    Exit;
  end;

  if (S[1] = '(') and (S[Length(S)] = ')') then
  begin
    j:=0;
    For i:=2 to Length(S) - 2 do
    begin
      if S[i] = '(' then Inc(j)
      else if S[i] = ')' then Dec(j);
      if j < 0 then Break;        {patri obe zavorky "k sobe" ?}
      if i = Length(S) - 2 then
      begin
        S:=Copy(S, 2, Length(S) - 2);
        VyhodnotLogickyVyraz:=VyhodnotLogickyVyraz(S);
        Exit;
      end;
    end;
  end;

  if Copy(S, 1, 3) = 'NOT' then
  begin
    S:=Copy(S, 4, Length(S) - 3);
    VyhodnotLogickyVyraz:=not VyhodnotLogickyVyraz(S);
    Exit;
  end;

  i:=Pos('=', S);
  i:=Max(i, Pos('>', S));
  i:=Max(i, Pos('<', S));
  if i > 1 then {kvuli S[i - 1]}
  begin
    j:=1;
    if (S[i - 1] = '<') or (S[i - 1] = '>') then c1:=VyhodnotCiselnyVyraz(S, j)
    else c1:=VyhodnotCiselnyVyraz(S, j);
    j:=i + 1;
    c2:=VyhodnotCiselnyVyraz(S, j);
    case S[i] of
      '=' : if S[i - 1] = '<' then
              if (c1 < c2) or (Abs(c1 - c2) <= Epsilon) then VyhodnotLogickyVyraz:=True
              else VyhodnotLogickyVyraz:=False
            else
            if S[i - 1] = '>' then
              if (c1 > c2) or (Abs(c1 - c2) <= Epsilon) then VyhodnotLogickyVyraz:=True
              else VyhodnotLogickyVyraz:=False
            else
              if Abs(c1 - c2) <= Epsilon then VyhodnotLogickyVyraz:=True
              else VyhodnotLogickyVyraz:=False;
      '>' : if S[i - 1] = '<' then
              if Abs(c1 - c2) > Epsilon then VyhodnotLogickyVyraz:=True
              else VyhodnotLogickyVyraz:=False
            else
              if c1 > c2 then VyhodnotLogickyVyraz:=True
              else VyhodnotLogickyVyraz:=False;
      '<' :   if c1 < c2 then VyhodnotLogickyVyraz:=True
              else VyhodnotLogickyVyraz:=False;

    end;
    Exit;
  end;

  Chyba(1);             {syntax error}
end;



{===== veci pro samotne vyhodnocovani prikazu ======}

Function NajdiNavesti(S :String) :Integer;
{vstup : S = cislo navesti, nic jineho}
{vystup : cislo radku}
var i, k:Integer;
begin
  OdstranMezery(S);
  if S = '' then Chyba(28);          {chybi cislo navesti}
  Val(S, i, k);
  if (k <> 0) or (i < 0) then Chyba(26);   {neplatne navesti}

  For k:=1 to PocRadku do
  if Prog^[k]^.Navesti = i then
  begin
    NajdiNavesti:=k;
    Exit;
  end;
  Chyba(29);          {nenalezeno navesti}
end;

Procedure VypisHodnotu(R :PromTyp);
var i :Integer;
    j :LongInt;
    x, y, z :PromTyp;
begin
  if (R > MaxLongInt) or (R < -MaxLongInt) or ((R <> 0) and (Abs(R) < Epsilon)) then
  begin
    Write(R);
    Exit;
  end;
  j:=1;
  x:=R;
  For i:=1 to VypisRZ + 1 do
  begin
    if ((R * j) > MaxLongInt) or ((R * j) < -MaxLongInt) then
    begin
      Write(R);
      Exit;
    end;
    if x >= 0 then y:=Int(x * j + 0.5)
    else y:=Int(x * j - 0.5);
    if Abs(y - x * j) > 0.01 then y:=Int(x * j);
    x:=x - y / j;
    if Abs(x) <= 2 / j * Epsilon then
    begin
      Write(R:0:i-1);
      Exit;
    end;
    j:=j * 10;
  end;
  Write(R);
end;


Procedure Vypis(Radek :Integer);
{vypis WRITE a PRINT}
var r :PromTyp;
    S :String;
    i :Integer;
begin
  S:=Prog^[Radek]^.Telo;
  S:=Copy(S, 7, Length(S));
  OdstranMezery(S);
  if S = '' then Exit;
  Repeat
    if S[1] = '"' then
    begin
      S:=Copy(S, 2, Length(S));
      i:=Pos('"', S);
      if i = 0 then Chyba(7);          {chybi uvozovky}
      Write(Copy(S, 1, i - 1));
      Inc(i);
    end
    else
    begin
      i:=1;
      r:=VyhodnotCiselnyVyraz(S, i);
      PosunPresMezery(S, i);
      VypisHodnotu(r);
      if i > Length(S) then Exit;
    end;
    S:=Copy(S, i, Length(S));
    OdstranMezery(S);
    if S = '' then Exit;
    if (S[1] <> ',') and (S[1] <> ';') then Chyba(9);  {chybi , nebo ; v PRINT}
    if S[1] = ',' then
    begin
      i:=WhereX + ((Odsazeni - ((WhereX - 1) mod Odsazeni)) mod Odsazeni);
      GotoXY(i, WhereY);
    end;
    S:=Copy(S, 2, Length(S));
    OdstranMezery(S);
  Until False;
end;


Function VyhodnotFOR(Radek :Integer; N :Boolean) :Boolean;
{vstupy : Radek = radek s FOR}
{         N = FALSE pokud se provadi FOR}
{             TRUE pokud se provadi NEXT}
{vystup : vraci TRUE, pokud se ma jit do cyklu}
var i, j, k :Integer;
    P :PPromenna;
    S, S1 :String;
    r1, r2 :PromTyp;
begin
  S:=Prog^[Radek]^.Telo;
  S:=Copy(S, 5, Length(S));
  i:=1;
  P:=VratPromennou(S, i, False);
  PosunPresMezery(S, i);
  if S[i] <> '=' then Chyba(6);          {chybi '=' }
  Inc(i);

  r1:=VyhodnotCiselnyVyraz(S, i);
  if not N then P^.Hodnota:=r1;

  PosunPresMezery(S, i);
  if Copy(S, i, 3) <> 'TO ' then Chyba(10);      {chybi 'TO' }
  i:=i + 3;

  r1:=VyhodnotCiselnyVyraz(S, i);

  PosunPresMezery(S, i);
  if Copy(S, i, 5) = 'STEP ' then
  begin
    i:=i + 5;
    r2:=VyhodnotCiselnyVyraz(S, i);
  end
  else r2:=1;
  PosunPresMezery(S, i);
  if i <= Length(S) then Chyba(1);     {syntax error}

  if N then P^.Hodnota:=P^.Hodnota + r2;

  if (Abs(r1 - P^.Hodnota) > Epsilon) and
       ( ((r2 > 0) and (P^.Hodnota > r1)) or
         ((r2 < 0) and (P^.Hodnota < r1))   )
        then begin
               if N then P^.Hodnota:=P^.Hodnota - r2;
               VyhodnotFOR:=False;
             end
  else VyhodnotFOR:=True;
end;

Procedure PrejdiNaZnacku;
{provede "goto" za radek se stejnou znackou jako je znacka na }
{na aktualnim radku; hledani je smerem dolu}
var i, k :Integer;
begin
  k:=Prog^[ProgRadek]^.Znacka;
  For i:=ProgRadek + 1 to PocRadku do if Prog^[i]^.Znacka = k then Break;
  ProgRadek:=i + 1;
end;

{===== samotny interpretr ===================}

Function VyhodnotPrikaz(Prikaz :String) :Boolean;
{vraci true, pokud sama skace nekam v programu}
{neni rekurzivni}
var i, j, k :Integer;
    S1, S2, S3 :String;
    P :PPromenna;
    R :PromTyp;
    xP :PPromTyp;
begin
  VyhodnotPrikaz:=False;

  i:=1;
  While (i <= Length(Prikaz)) and (Prikaz[i] <> ' ') do Inc(i);

  S1:=Copy(Prikaz, 1, i - 1);
  if S1 = 'REM' then
  begin
    {nic se nedeje}
  end
  else
  if S1 = 'END' then
  begin
    DisposeProgram;
    Done;
    Halt(0);
  end
  else
  if S1 = 'GOTO' then
  begin
    i:=NajdiNavesti(Copy(Prikaz, i , Length(Prikaz)));
    ProgRadek:=i;
    VyhodnotPrikaz:=True;
  end
  else
  if S1 = 'GOSUB' then
  begin
    if PocGosubOdkazu >= MaxPocOdkazu then Chyba(32);  {prilis mnoho podprogramu}
    i:=NajdiNavesti(Copy(Prikaz, i, Length(Prikaz)));
    Inc(PocGosubOdkazu);
    GosubOdkazy[PocGosubOdkazu]:=ProgRadek + 1;
    ProgRadek:=i;
    VyhodnotPrikaz:=True;
  end
  else
  if S1 = 'RETURN' then
  begin
    if PocGosubOdkazu <= 0 then Chyba(13);  {pro RETURN chybi GOSUB}
    ProgRadek:=GosubOdkazy[PocGosubOdkazu];
    Dec(PocGosubOdkazu);
    VyhodnotPrikaz:=True;
  end
  else
  if S1 = 'FOR' then
  begin
    if not VyhodnotFOR(ProgRadek, False) then
    begin
      VyhodnotPrikaz:=True;
      PrejdiNaZnacku;
    end;
  end
  else
  if S1 = 'NEXT' then
  begin
    k:=Prog^[ProgRadek]^.Znacka;
    For i:=ProgRadek - 1 downto 1 do if Prog^[i]^.Znacka = k then Break;
    if VyhodnotFOR(i, True) then
    begin
      VyhodnotPrikaz:=True;
      ProgRadek:=i + 1;
    end;
  end
  else
  if S1 = 'LET' then
  begin
    S1:=Copy(Prikaz, 4, Length(Prikaz));
    i:=1;
    xP:=VratPromennouNeboPole(S1, i, False);
    PosunPresMezery(S1, i);
    if S1[i] <> '=' then Chyba(6);          {chybi '=' }
    Inc(i);
    xP^:=VyhodnotCiselnyVyraz(S1, i);
    if i <= Length(S1) then Chyba(1);   {syntax error}
  end
  else
  if S1 = 'IF' then
  begin
    S1:=Copy(Prikaz, 3, Length(Prikaz));
    i:=NajdiProgRetezec(S1, 'THEN', 1, True);
    if i = 0 then Chyba(11);          {chybi THEN}
    S2:=Copy(S1, i + 4, Length(S1));
    OdstranMezery(S2);
    if not VyhodnotLogickyVyraz(Copy(S1, 1, i - 1)) then
    begin
      VyhodnotPrikaz:=True;
      PrejdiNaZnacku;
    end;
  end
  else
  if S1 = 'ELSE' then
  begin
    VyhodnotPrikaz:=True;
    PrejdiNaZnacku;
  end
  else
  if S1 = 'ENDIF' then
  begin
  end
  else
  if S1 = 'INPUT' then
  begin
    S1:=Copy(Prikaz, 6, Length(Prikaz));
    OdstranMezery(S1);
    if S1[1] = '"' then
    begin
      S1:=Copy(S1, 2, Length(S1));
      i:=Pos('"', S1);
      if i = 0 then Chyba(7);          {chybi uvozovky}
      S2:=Copy(S1, 1, i - 1);
      S1:=Copy(S1, i + 1, Length(S1));
      OdstranMezery(S1);
      if S1[1] <> ',' then Chyba(8);   {chybi , v INPUT}
      S1:=Copy(S1, 2, Length(S1));
    end
    else S2:='? ';
    OdstranMezery(S1);
    j:=1;
    xP:=VratPromennouNeboPole(S1, j, True);
    PosunPresMezery(S1, j);
    if j <= Length(S1) then Chyba(1);   {syntax error}
    Repeat
      Write(S2);
      ReadLn(S3);
      Val(S3, R, i);
      if i <> 0 then Writeln('Chybne zadani, opakuj');
    Until i = 0;
    xP^:=R;
  end
  else
  if S1 = 'WRITE' then
  begin
    Vypis(ProgRadek);
  end
  else
  if S1 = 'PRINT' then
  begin
    Vypis(ProgRadek);
    Writeln;
  end
  else
  if S1 = 'CLS' then
  begin
    ClrScr;
  end
  else
  if S1 = 'DIM' then
  begin
    i:=5;
    PridejPole(Prikaz, i);
  end
  else
  if S1 = 'RANDOMIZE' then
  begin
    S1:=Copy(Prikaz, 11, Length(Prikaz));
    OdstranMezery(S1);
    if S1 = '' then Chyba(34);                  {chybi zdroj nahodnych cisel}
    if S1 = 'TIMER' then Randomize
    else
    begin
     k:=1;
     r:=VyhodnotCiselnyVyraz(S1, k);
     if r > MaxLongInt then r:=MaxLongInt;
     if r < -MaxLongInt then r:=-MaxLongInt;
     RandSeed:=Round(r);
    end;
  end
  else
  if S1 = 'SLEEP' then
  begin
    i:=7;
    r:=VyhodnotCiselnyVyraz(Prikaz, i);
    if (r < -MaxInt) or (r > MaxInt) then Chyba(37); { 0<=r<=30000 }
    if Abs(r - Round(r)) > Epsilon then Chyba(30); {ocekavana celociselna hodnota}
    i:=Round(r);
    if (i < 0) or (i > 30000) then Chyba(37);            { 0<=r<=30000 }
    Delay(i);
  end
  else Chyba(1);       {syntax error}
end;



{==== Hlavni procedury =====================}

Procedure Init;
begin
  PocPromennych:=0;
  PocPoli:=0;
  PocGosubOdkazu:=0;
  New(Promenne);
  New(Pole);

  PocRadku:=0;
  New(Prog);
end;

Procedure Done;
begin
  Dispose(Prog);
  DealokacePoli;
  Dispose(Pole);
  Dispose(Promenne);
end;

Procedure LoadProgram(Name :String);
var F :Text;
    S, S1, S2 :String;
    Cis, i, j, k, Nav, IFy :Integer;
begin
  PocRadku:=0;
  Cis:=0;
  {$I-}
  Assign(F, Name);
  Reset(F);
  if IOResult <> 0 then Chyba(35);  {neexistujici soubor}
  While not Eof(F) do
  begin
    ReadLn(F, S);
    Inc(Cis);
    OdstranMezery(S);
    SpecUpCase(S);
    OdstranNadbytecnaPlusAMinus(S);
    if (S = '') or (S[1] = '''') then Continue;  {vyhozeni uplne prazdnych radku a komentare}

    {navesti}
    j:=1;
    While (j <= Length(S)) and (S[j] <> ' ') do Inc(j);
    Val(Copy(S, 1, j - 1), i, k);
    if k = 0 then
    begin
      if i <= 0 then
      begin
        ProgRadek:=-Cis;
        Chyba(26);  {neplatne navesti}
      end;
      For k:=1 to PocRadku - 1 do
      if Prog^[k]^.Navesti = i then
      begin
        ProgRadek:=-Cis;
        Chyba(27); {duplicitni navesti}
      end;
      Nav:=i;
      S:=Copy(S, j + 1, Length(S));
      OdstranMezery(S);
    end
    else Nav:=-1;

    IFy:=0;
    Repeat
      i:=NajdiProgRetezec(S, ':', 1, False);
      if i = 0 then i:=Length(S) + 1;
      S1:=Copy(S, 1, i - 1);
      OdstranMezery(S1); {zleva uz ale zadne mezery nejsou}
      if Copy(S1, 1, 3) = 'IF ' then
      begin
        j:=NajdiProgRetezec(S1, 'THEN', 1, True);
        if j = 0 then Chyba(11);       {chybi THEN}
        S2:=Copy(S, j + 4, Length(S));
        OdstranMezery(S2);
        if S2 <> '' then  { THEN:  se chape uz jako s prikazem; ne tedy typ IF ENDIF}
        begin
          S[j + 4]:= ':';
          Inc(IFy);
          i:=j + 4;
          S1:=Copy(S1, 1, j + 3);
        end;
      end;
      if Copy(S1, 1, 5) = 'ELSE ' then
      begin
        S[5]:=':';
        i:=5;
        S1:='ELSE';
      end;

      Inc(PocRadku);
      if PocRadku > MaxPocRadku then
      begin
        ProgRadek:=-PocRadku;
        Chyba(33); {prilis mnoho Radku}
      end;
{      New(Prog^[PocRadku]);}
      GetMem(Prog^[PocRadku], 3 * SizeOf(Integer) + 1 + Length(S1));
      With Prog^[PocRadku]^ do
      begin
        Cislo:=Cis;
        Navesti:=Nav;
        Nav:=-1;
        Znacka:=0;
        Telo:=S1;
      end;

      S:=Copy(S, i + 1, Length(S));
      OdstranMezery(S);
    Until S = '';

    While IFy > 0 do   {pridani ENDIFu}
    begin
      Inc(PocRadku);
      if PocRadku > MaxPocRadku then
      begin
        ProgRadek:=-PocRadku;
        Chyba(33); {prilis mnoho Radku}
      end;
      New(Prog^[PocRadku]);
      With Prog^[PocRadku]^ do
      begin
        Cislo:=Cis;
        Navesti:=-1;
        Znacka:=0;
        Telo:='ENDIF';
      end;
      Dec(IFy);
    end;
  end;

  New(Prog^[PocRadku + 1]);   {zarazka}
  With Prog^[PocRadku + 1]^ do
  begin
    Cislo:=0;
    Navesti:=-1;
    Znacka:=0;
    Telo:='';
  end;
  Close(F);
  {$I+}
end;

Procedure ZnackovyPreprocesor;
{pozn :vyuzivam zarazky v programu ... Prog^[PocRadku+1]^.Telo = '' }
var Zn :Integer;
    Radek :Integer;
  Procedure Blok;
  var S, S1 :String;
      i :Integer;
  begin
    While Radek <= PocRadku do
    begin
      S:=Prog^[Radek]^.Telo;
      if Copy(S, 1, 3) = 'IF ' then
      begin
        Inc(Zn);
        i:=Zn;
        Prog^[Radek]^.Znacka:=i;
        Inc(Radek);
        Blok;
        S:=Prog^[Radek]^.Telo;
        if S = 'ELSE' then
        begin
          Prog^[Radek]^.Znacka:=i;
          Inc(Radek);
          Blok;
          S:=Prog^[Radek]^.Telo;
        end;
        if S <> 'ENDIF' then
        begin
          ProgRadek:=Radek;
          Chyba(12);   {chybi ENDIF}
        end;
        Prog^[Radek]^.Znacka:=i;
      end
      else
      if Copy(S, 1, 4) = 'FOR ' then
      begin
        {nalezeni jmena promenne}
        i:=NajdiProgRetezec(S, '=', 5, False);
        if i = 0 then
        begin
          ProgRadek:=Radek;
          Chyba(6);                     {chybi = }
        end;
        S1:=Copy(S, 5, i - 5);
        OdstranMezery(S1);

        Inc(Zn);
        i:=Zn;
        Prog^[Radek]^.Znacka:=i;
        Inc(Radek);
        Blok;
        S:=Prog^[Radek]^.Telo;
        if Copy(S, 1, 5) <> 'NEXT ' then
        begin
          ProgRadek:=Radek;
          Chyba(14);   {chybi NEXT}
        end;
        S:=Copy(S, 6, Length(S));
        OdstranMezery(S);
        if S <> S1 then
        begin
          ProgRadek:=Radek;
          Chyba(15);              {NEXT bez FOR (spatna promenna)}
        end;
        Prog^[Radek]^.Znacka:=i;
      end
      else
      if (Copy(S, 1, 5) = 'NEXT ') or (S = 'ELSE') or (S = 'ENDIF') then Exit;
      Inc(Radek);
    end;
  end;
begin
  Radek:=1;
  Zn:=0;
  Blok;
end;

Procedure DisposeProgram;
var i :Integer;
begin
  For i:=PocRadku downto 1 do
    { Dispose(Prog^[i]);}
      FreeMem(Prog^[i], 3 * SizeOf(Integer) + 1 + Length(Prog^[i]^.Telo));

end;

Procedure ExecuteProgram;
var i :Integer;
    S :String;
begin
  ProgRadek:=1;
  While ProgRadek <= PocRadku do
  begin
    S:=Prog^[ProgRadek]^.Telo;
    if (S = '') or not VyhodnotPrikaz(Prog^[ProgRadek]^.Telo) then Inc(ProgRadek);
  end;
end;

{$F+}
Procedure ErrorExit;
begin
  ExitProc:=OldExitProc;
  if ErrorAddr <> nil then Chyba(ExitCode);
end;
{$F-}


BEGIN
  ExitProc:=@ErrorExit;
  Init;
  if ParamCount < 1 then
  begin
    { Chyba(36);  chybi zdrojak}
    Writeln('Usage: BASIC name_of_source_file');
    Exit;
  end;
  LoadProgram(ParamStr(1));
  ZnackovyPreprocesor;
  ExecuteProgram;
  DisposeProgram;
  Done;

  While Keypressed do ReadKey;
  Writeln;
END.